### Constructor

# Cogl Texture2DSliced new_with_size

#### Declaration [src]

    CoglTexture*
    cogl_texture_2d_sliced_new_with_size (
      CoglContext* ctx,
      int width,
      int height,
      int max_waste
    )

#### Description [src]

Creates a `CoglTexture2DSliced` that may internally be comprised of 1 or more `CoglTexture2D` textures depending on GPU limitations. For example if the GPU only supports power-of-two sized textures then a sliced texture will turn a non-power-of-two size into a combination of smaller power-of-two sized textures. If the requested texture size is larger than is supported by the hardware then the texture will be sliced into smaller textures that can be accessed by the hardware.

`max_waste` is used as a threshold for recursively slicing the right-most or bottom-most slices into smaller sizes until the wasted padding at the bottom and right of the textures is less than specified. A negative `max_waste` will disable slicing.

The storage for the texture is not allocated before this function returns. You can call `cogl_texture_allocate()` to explicitly allocate the underlying storage or let Cogl automatically allocate storage lazily.

It’s possible for the allocation of a sliced texture to fail later due to impossible slicing constraints if a negative `max_waste` value is given. If the given virtual texture size size is larger than is supported by the hardware but slicing is disabled the texture size would be too large to handle.

#### Parameters

`ctx`

  Type: `CoglContext`

  A `CoglContext`.

  The data is owned by the caller of the function.

`width`

  Type: `int`

  The virtual width of your sliced texture.

`height`

  Type: `int`

  The virtual height of your sliced texture.

`max_waste`

  Type: `int`

  The threshold of how wide a strip of wasted texels are allowed along the right and bottom textures before they must be sliced to reduce the amount of waste. A negative can be passed to disable slicing.

#### Return value

Type: `CoglTexture`

A new `CoglTexture2DSliced` object with no storage allocated yet.

The caller of the function takes ownership of the data, and is responsible for freeing it.